Index: /branches/SHM-2.0-dev/cfg/encoder_intra_main.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_intra_main.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_intra_main.cfg	(revision 132)
@@ -39,6 +39,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: /branches/SHM-2.0-dev/cfg/encoder_intra_main10.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_intra_main10.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_intra_main10.cfg	(revision 132)
@@ -39,6 +39,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: /branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 132)
@@ -23,5 +23,4 @@
 Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -45,6 +44,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: /branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main10.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main10.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main10.cfg	(revision 132)
@@ -23,5 +23,4 @@
 Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -47,6 +46,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: /branches/SHM-2.0-dev/cfg/encoder_lowdelay_main.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_lowdelay_main.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_lowdelay_main.cfg	(revision 132)
@@ -23,5 +23,4 @@
 Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -45,6 +44,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: /branches/SHM-2.0-dev/cfg/encoder_lowdelay_main10.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_lowdelay_main10.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_lowdelay_main10.cfg	(revision 132)
@@ -23,5 +23,4 @@
 Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -45,6 +44,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: /branches/SHM-2.0-dev/cfg/encoder_randomaccess_main.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_randomaccess_main.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_randomaccess_main.cfg	(revision 132)
@@ -27,5 +27,4 @@
 Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
 Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -49,7 +48,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
-
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: /branches/SHM-2.0-dev/cfg/encoder_randomaccess_main10.cfg
===================================================================
--- /branches/SHM-2.0-dev/cfg/encoder_randomaccess_main10.cfg	(revision 131)
+++ /branches/SHM-2.0-dev/cfg/encoder_randomaccess_main10.cfg	(revision 132)
@@ -27,5 +27,4 @@
 Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
 Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -49,6 +48,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============